diff --git a/plugins/decoration.c b/plugins/decoration.c
index 003685f..a7a8d47 100644
--- a/plugins/decoration.c
+++ b/plugins/decoration.c
@@ -121,10 +121,6 @@ typedef struct _DecorDisplay {
 typedef struct _DecorScreen {
     int	windowPrivateIndex;
 
-    Window dmWin;
-
-    Decoration *decor[DECOR_NUM];
-
     DrawWindowProc		  drawWindow;
     DamageWindowRectProc	  damageWindowRect;
     GetOutputExtentsForWindowProc getOutputExtentsForWindow;
@@ -139,7 +135,11 @@ typedef struct _DecorScreen {
 
 typedef struct _DecorWindow {
     WindowDecoration *wd;
-    Decoration	     *decor;
+
+    Window dmWin;
+    Window wmWin;
+
+    Decoration *decor[DECOR_NUM];
 
     CompTimeoutHandle resizeUpdateHandle;
 } DecorWindow;
@@ -188,6 +188,15 @@ decorDrawWindow (CompWindow	      *w,
     status = (*w->screen->drawWindow) (w, transform, attrib, region, mask);
     WRAP (ds, w->screen, drawWindow, decorDrawWindow);
 
+    if (!w->shaded)
+    {
+	if (w->attrib.map_state != IsViewable)
+	    return status;
+
+	if (!w->damaged)
+	    return status;
+    }
+
     if (mask & PAINT_WINDOW_TRANSFORMED_MASK)
 	region = &infiniteRegion;
 
@@ -224,7 +233,7 @@ decorDrawWindow (CompWindow	      *w,
 					     attrib, mask);
     }
 
-    return status;
+    return TRUE;
 }
 
 static DecorTexture *
@@ -261,19 +270,26 @@ decorGetTexture (CompScreen *screen,
 	return NULL;
     }
 
-    if (!bindPixmapToTexture (screen, &texture->texture, pixmap,
-			      width, height, depth))
+    if (manualCompositeManagement)
     {
-	finiTexture (screen, &texture->texture);
-	free (texture);
-	return NULL;
-    }
+	if (!bindPixmapToTexture (screen, &texture->texture, pixmap,
+				  width, height, depth))
+	{
+	    finiTexture (screen, &texture->texture);
+	    free (texture);
+	    return NULL;
+	}
 
-    if (!dd->opt[DECOR_DISPLAY_OPTION_MIPMAP].value.b)
-	texture->texture.mipmap = FALSE;
+	if (!dd->opt[DECOR_DISPLAY_OPTION_MIPMAP].value.b)
+	    texture->texture.mipmap = FALSE;
 
-    texture->damage = XDamageCreate (screen->display->display, pixmap,
-				     XDamageReportRawRectangles);
+	texture->damage = XDamageCreate (screen->display->display, pixmap,
+					 XDamageReportRawRectangles);
+    }
+    else
+    {
+	texture->damage = None;
+    }
 
     texture->refCount = 1;
     texture->pixmap   = pixmap;
@@ -410,7 +426,7 @@ decorCreateDecoration (CompScreen *screen,
 
     result = XGetWindowProperty (screen->display->display, id,
 				 decorAtom, 0L, 1024L, FALSE,
-				 XA_INTEGER, &actual, &format,
+				 0, &actual, &format,
 				 &n, &nleft, &data);
 
     if (result != Success || !n || !data)
@@ -532,19 +548,20 @@ decorReleaseDecoration (CompScreen *screen,
 }
 
 static void
-decorWindowUpdateDecoration (CompWindow *w)
+decorWindowUpdateDecoration (CompWindow *w,
+			     Atom       atom,
+			     int        type)
 {
     Decoration *decoration;
 
-    DECOR_DISPLAY (w->screen->display);
     DECOR_WINDOW (w);
 
-    decoration = decorCreateDecoration (w->screen, w->id, dd->winDecorAtom);
+    decoration = decorCreateDecoration (w->screen, w->id, atom);
 
-    if (dw->decor)
-	decorReleaseDecoration (w->screen, dw->decor);
+    if (dw->decor[type])
+	decorReleaseDecoration (w->screen, dw->decor[type]);
 
-    dw->decor = decoration;
+    dw->decor[type] = decoration;
 }
 
 static WindowDecoration *
@@ -654,6 +671,9 @@ updateWindowDecorationScale (CompWindow *w)
     if (!wd)
 	return;
 
+    if (!manualCompositeManagement)
+	return;
+
     for (i = 0; i < wd->nQuad; i++)
     {
 	computeQuadBox (&wd->decor->quad[i], w->width, w->height,
@@ -712,6 +732,17 @@ decorWindowShiftY (CompWindow *w)
 }
 
 static Bool
+decorIsActiveWindow (CompWindow *w)
+{
+    for (; w->parent; w = w->parent)
+    	if (w->parent->redirectSubwindows || w->parent->substructureRedirect)
+	    if (w->parent->activeChild != w->id)
+		return FALSE;
+
+    return TRUE;
+}
+
+static Bool
 decorWindowUpdate (CompWindow *w,
 		   Bool	      allowDecoration)
 {
@@ -727,6 +758,9 @@ decorWindowUpdate (CompWindow *w,
     DECOR_SCREEN (w->screen);
     DECOR_WINDOW (w);
 
+    if (!w->parent)
+	return FALSE;
+
     wd = dw->wd;
     old = (wd) ? wd->decor : NULL;
 
@@ -742,6 +776,9 @@ decorWindowUpdate (CompWindow *w,
 	break;
     }
 
+    if (!GET_DECOR_WINDOW (w->parent, ds)->wmWin)
+	decorate = FALSE;
+
     if (w->attrib.override_redirect)
 	decorate = FALSE;
 
@@ -754,16 +791,16 @@ decorWindowUpdate (CompWindow *w,
 
     if (decorate)
     {
-	if (dw->decor && decorCheckSize (w, dw->decor))
+	decor = dw->decor[DECOR_NORMAL];
+	if (decorIsActiveWindow (w) && dw->decor[DECOR_ACTIVE])
+	    decor = dw->decor[DECOR_ACTIVE];
+		    
+	if (!decor || !decorCheckSize (w, decor))
 	{
-	    decor = dw->decor;
-	}
-	else
-	{
-	    if (w->id == w->screen->display->activeWindow)
-		decor = ds->decor[DECOR_ACTIVE];
+	    if (decorIsActiveWindow (w))
+		decor = GET_DECOR_WINDOW (w->parent, ds)->decor[DECOR_ACTIVE];
 	    else
-		decor = ds->decor[DECOR_NORMAL];
+		decor = GET_DECOR_WINDOW (w->parent, ds)->decor[DECOR_NORMAL];
 	}
     }
     else
@@ -772,7 +809,7 @@ decorWindowUpdate (CompWindow *w,
 	if (matchEval (match, w))
 	{
 	    if (w->region->numRects == 1)
-		decor = ds->decor[DECOR_BARE];
+		decor = GET_DECOR_WINDOW (w->parent, ds)->decor[DECOR_BARE];
 
 	    if (decor)
 	    {
@@ -782,7 +819,7 @@ decorWindowUpdate (CompWindow *w,
 	}
     }
 
-    if (!ds->dmWin || !allowDecoration)
+    if (!GET_DECOR_WINDOW (w->parent, ds)->dmWin || !allowDecoration)
 	decor = NULL;
 
     if (decor == old)
@@ -829,7 +866,7 @@ decorWindowUpdate (CompWindow *w,
 	moveDy = -oldShiftY;
     }
 
-    if (w->placed && !w->attrib.override_redirect && (moveDx || moveDy))
+    if (w->placed && w->managed && (moveDx || moveDy))
     {
 	XWindowChanges xwc;
 	unsigned int   mask = CWX | CWY;
@@ -860,20 +897,34 @@ decorWindowUpdate (CompWindow *w,
 }
 
 static void
-decorCheckForDmOnScreen (CompScreen *s,
-			 Bool	    updateWindows)
+decorWindowUpdateTree (CompWindow *ancestor,
+		       Bool       allowDecoration)
+{
+    CompWindow *w;
+
+    w = ancestor;
+    do {
+	decorWindowUpdate (w, allowDecoration);
+    } while ((w = walkDepthFirst (w)) && w != ancestor);
+}
+
+static void
+decorCheckForDm (CompWindow *w,
+		 Bool	    updateWindows)
 {
+    CompScreen    *s = w->screen;
     CompDisplay   *d = s->display;
     Atom	  actual;
     int		  result, format;
     unsigned long n, left;
     unsigned char *data;
     Window	  dmWin = None;
+    Window	  wmWin = w->supportingWmCheckWindow;
 
     DECOR_DISPLAY (s->display);
-    DECOR_SCREEN (s);
+    DECOR_WINDOW (w);
 
-    result = XGetWindowProperty (d->display, s->root,
+    result = XGetWindowProperty (d->display, w->id,
 				 dd->supportingDmCheckAtom, 0L, 1L, FALSE,
 				 XA_WINDOW, &actual, &format,
 				 &n, &left, &data);
@@ -893,46 +944,58 @@ decorCheckForDmOnScreen (CompScreen *s,
 	    dmWin = None;
     }
 
-    if (dmWin != ds->dmWin)
+    if (dmWin != dw->dmWin)
     {
-	CompWindow *w;
+	CompWindow *c;
 	int	   i;
 
 	if (dmWin)
 	{
 	    for (i = 0; i < DECOR_NUM; i++)
-		ds->decor[i] =
-		    decorCreateDecoration (s, s->root, dd->decorAtom[i]);
+		dw->decor[i] = decorCreateDecoration (s,
+						      w->id,
+						      dd->decorAtom[i]);
 	}
 	else
 	{
+	    DECOR_SCREEN (w->screen);
+
 	    for (i = 0; i < DECOR_NUM; i++)
 	    {
-		if (ds->decor[i])
+		if (dw->decor[i])
 		{
-		    decorReleaseDecoration (s, ds->decor[i]);
-		    ds->decor[i] = 0;
+		    decorReleaseDecoration (s, dw->decor[i]);
+		    dw->decor[i] = 0;
 		}
 	    }
 
-	    for (w = s->windows; w; w = w->next)
+	    for (c = w->windows; c; c = c->next)
 	    {
-		DECOR_WINDOW (w);
+		DecorWindow *dc = GET_DECOR_WINDOW (c, ds);
 
-		if (dw->decor)
+		for (i = 0; i < DECOR_NUM; i++)
 		{
-		    decorReleaseDecoration (s, dw->decor);
-		    dw->decor = 0;
+		    if (dc->decor[i])
+		    {
+			decorReleaseDecoration (s, dc->decor[i]);
+			dc->decor[i] = 0;
+		    }
 		}
 	    }
 	}
+    }
 
-	ds->dmWin = dmWin;
+    if ((wmWin != dw->wmWin) || (dmWin != dw->dmWin))
+    {
+	dw->wmWin = wmWin;
+	dw->dmWin = dmWin;
 
 	if (updateWindows)
 	{
-	    for (w = s->windows; w; w = w->next)
-		decorWindowUpdate (w, TRUE);
+	    CompWindow *c;
+
+	    for (c = w->windows; c; c = c->next)
+		decorWindowUpdate (c, TRUE);
 	}
     }
 }
@@ -941,7 +1004,6 @@ static void
 decorHandleEvent (CompDisplay *d,
 		  XEvent      *event)
 {
-    Window     activeWindow = d->activeWindow;
     CompWindow *w;
 
     DECOR_DISPLAY (d);
@@ -949,12 +1011,16 @@ decorHandleEvent (CompDisplay *d,
     switch (event->type) {
     case DestroyNotify:
 	w = findWindowAtDisplay (d, event->xdestroywindow.window);
-	if (w)
+	if (w && (w = w->parent))
 	{
-	    DECOR_SCREEN (w->screen);
+	    DECOR_WINDOW (w);
 
-	    if (w->id == ds->dmWin)
-		decorCheckForDmOnScreen (w->screen, TRUE);
+	    if (w->supportingWmCheckWindow == event->xdestroywindow.window)
+		getSupportingWmCheck (w);
+
+	    if (event->xdestroywindow.window == dw->wmWin ||
+		event->xdestroywindow.window == dw->dmWin)
+		decorCheckForDm (w, TRUE);
 	}
 	break;
     case MapRequest:
@@ -982,7 +1048,7 @@ decorHandleEvent (CompDisplay *d,
 		    {
 			ds = GET_DECOR_SCREEN (s, dd);
 
-			for (w = s->windows; w; w = w->next)
+			for (w = s->root.windows; w; w = walkDepthFirst (w))
 			{
 			    if (w->shaded || w->mapNum)
 			    {
@@ -1004,25 +1070,47 @@ decorHandleEvent (CompDisplay *d,
     (*d->handleEvent) (d, event);
     WRAP (dd, d, handleEvent, decorHandleEvent);
 
-    if (d->activeWindow != activeWindow)
-    {
-	w = findWindowAtDisplay (d, activeWindow);
-	if (w)
-	    decorWindowUpdate (w, TRUE);
-
-	w = findWindowAtDisplay (d, d->activeWindow);
-	if (w)
-	    decorWindowUpdate (w, TRUE);
-    }
-
     switch (event->type) {
+    case FocusIn:
+	if (event->xfocus.mode != NotifyGrab)
+	{
+	    w = findTopLevelWindowAtDisplay (d, event->xfocus.window);
+	    if (w && w->managed && (w = w->parent))
+	    {
+		CompWindow *c;
+
+		for (c = w->windows; c; c = c->next)
+		    if (c->id == w->previousActiveChild ||
+			c->id == w->activeChild)
+			decorWindowUpdateTree (c, TRUE);
+	    }
+	}
+	break;
     case PropertyNotify:
-	if (event->xproperty.atom == dd->winDecorAtom)
+	if (event->xproperty.atom == d->winActiveAtom)
+	{
+	    w = findWindowAtDisplay (d, event->xproperty.window);
+	    if (w)
+	    {	
+		if (!w->substructureRedirect)
+		{
+		    CompWindow *c;
+
+		    for (c = w->windows; c; c = c->next)
+			if (c->id == w->previousActiveChild ||
+			    c->id == w->activeChild)
+			    decorWindowUpdateTree (c, TRUE);
+		}
+	    }
+	}
+	else if (event->xproperty.atom == dd->winDecorAtom)
 	{
 	    w = findWindowAtDisplay (d, event->xproperty.window);
 	    if (w)
 	    {
-		decorWindowUpdateDecoration (w);
+		decorWindowUpdateDecoration (w,
+					     dd->winDecorAtom,
+					     DECOR_NORMAL);
 		decorWindowUpdate (w, TRUE);
 	    }
 	}
@@ -1034,14 +1122,13 @@ decorHandleEvent (CompDisplay *d,
 	}
 	else
 	{
-	    CompScreen *s;
-
-	    s = findScreenAtDisplay (d, event->xproperty.window);
-	    if (s)
+	    w = findWindowAtDisplay (d, event->xproperty.window);
+	    if (w)
 	    {
-		if (event->xproperty.atom == dd->supportingDmCheckAtom)
+		if (event->xproperty.atom == d->supportingWmCheckAtom ||
+		    event->xproperty.atom == dd->supportingDmCheckAtom)
 		{
-		    decorCheckForDmOnScreen (s, TRUE);
+		    decorCheckForDm (w, TRUE);
 		}
 		else
 		{
@@ -1051,17 +1138,23 @@ decorHandleEvent (CompDisplay *d,
 		    {
 			if (event->xproperty.atom == dd->decorAtom[i])
 			{
-			    DECOR_SCREEN (s);
+			    DECOR_WINDOW (w);
 
-			    if (ds->decor[i])
-				decorReleaseDecoration (s, ds->decor[i]);
+			    decorWindowUpdateDecoration (w,
+							 dd->decorAtom[i],
+							 i);
 
-			    ds->decor[i] =
-				decorCreateDecoration (s, s->root,
-						       dd->decorAtom[i]);
+			    if (dw->dmWin)
+			    {
+				CompWindow *c;
 
-			    for (w = s->windows; w; w = w->next)
+				for (c = w->windows; c; c = c->next)
+				    decorWindowUpdate (c, TRUE);
+			    }
+			    else
+			    {
 				decorWindowUpdate (w, TRUE);
+			    }
 			}
 		    }
 		}
@@ -1132,10 +1225,11 @@ decorStartDecorator (void *closure)
 
     DECOR_DISPLAY (s->display);
     DECOR_SCREEN (s);
+    DECOR_WINDOW ((&s->root));
 
     ds->decoratorStartHandle = 0;
 
-    if (!ds->dmWin)
+    if (!dw->dmWin)
 	runCommand (s, dd->opt[DECOR_DISPLAY_OPTION_COMMAND].value.s);
 
     return FALSE;
@@ -1175,10 +1269,14 @@ decorSetDisplayOption (CompPlugin      *plugin,
 
 	    for (s = display->screens; s; s = s->next)
 	    {
+		DECOR_WINDOW ((&s->root));
 		DECOR_SCREEN (s);
 
-		if (!ds->dmWin)
-		    runCommand (s, o->value.s);
+		if (!dw->dmWin && !ds->decoratorStartHandle)
+		    ds->decoratorStartHandle =
+			compAddTimeout (0, -1,
+					decorStartDecorator,
+					s);
 	    }
 
 	    return TRUE;
@@ -1221,11 +1319,9 @@ decorSetDisplayOption (CompPlugin      *plugin,
 	if (compSetMatchOption (o, value))
 	{
 	    CompScreen *s;
-	    CompWindow *w;
 
 	    for (s = display->screens; s; s = s->next)
-		for (w = s->windows; w; w = w->next)
-		    decorWindowUpdate (w, TRUE);
+		decorWindowUpdateTree (&s->root, TRUE);
 	}
 	break;
     default:
@@ -1246,7 +1342,7 @@ decorWindowMoveNotify (CompWindow *w,
     DECOR_SCREEN (w->screen);
     DECOR_WINDOW (w);
 
-    if (dw->wd)
+    if (dw->wd && w->parent && w->parent->redirectSubwindows)
     {
 	WindowDecoration *wd = dw->wd;
 	int		 i;
@@ -1291,15 +1387,21 @@ decorWindowResizeNotify (CompWindow *w,
     DECOR_SCREEN (w->screen);
     DECOR_WINDOW (w);
 
-    /* FIXME: we should not need a timer for calling decorWindowUpdate,
-       and only call updateWindowDecorationScale if decorWindowUpdate
-       returns FALSE. Unfortunately, decorWindowUpdate may call
-       updateWindowOutputExtents, which may call WindowResizeNotify. As
-       we never should call a wrapped function that's currently
-       processed, we need the timer for the moment. updateWindowOutputExtents
-       should be fixed so that it does not emit a resize notification. */
-    dw->resizeUpdateHandle = compAddTimeout (0, 0, decorResizeUpdateTimeout, w);
-    updateWindowDecorationScale (w);
+    if (w->parent && w->parent->redirectSubwindows)
+    {
+	/* FIXME: we should not need a timer for calling decorWindowUpdate,
+	   and only call updateWindowDecorationScale if decorWindowUpdate
+	   returns FALSE. Unfortunately, decorWindowUpdate may call
+	   updateWindowOutputExtents, which may call WindowResizeNotify. As
+	   we never should call a wrapped function that's currently
+	   processed, we need the timer for the moment.
+	   updateWindowOutputExtents should be fixed so that it does not
+	   emit a resize notification. */
+	if (!dw->resizeUpdateHandle)
+	    dw->resizeUpdateHandle =
+		compAddTimeout (0, 0, decorResizeUpdateTimeout, w);
+	updateWindowDecorationScale (w);
+    }
 
     UNWRAP (ds, w->screen, windowResizeNotify);
     (*w->screen->windowResizeNotify) (w, dx, dy, dwidth, dheight);
@@ -1343,7 +1445,7 @@ decorMatchPropertyChanged (CompDisplay *d,
 }
 
 static void
-decorWindowAdd (CompScreen *s,
+decorWindowAdd (CompObject *parent,
 		CompWindow *w)
 {
     if (w->shaded || w->attrib.map_state == IsViewable)
@@ -1351,7 +1453,7 @@ decorWindowAdd (CompScreen *s,
 }
 
 static void
-decorWindowRemove (CompScreen *s,
+decorWindowRemove (CompObject *parent,
 		   CompWindow *w)
 {
     if (!w->destroyed)
@@ -1536,9 +1638,6 @@ decorInitScreen (CompPlugin *p,
 	return FALSE;
     }
 
-    memset (ds->decor, 0, sizeof (ds->decor));
-
-    ds->dmWin                = None;
     ds->decoratorStartHandle = 0;
 
     WRAP (ds, s, drawWindow, decorDrawWindow);
@@ -1550,12 +1649,6 @@ decorInitScreen (CompPlugin *p,
 
     s->base.privates[dd->screenPrivateIndex].ptr = ds;
 
-    decorCheckForDmOnScreen (s, FALSE);
-
-    if (!ds->dmWin)
-	ds->decoratorStartHandle = compAddTimeout (0, -1,
-						   decorStartDecorator, s);
-
     return TRUE;
 }
 
@@ -1563,14 +1656,8 @@ static void
 decorFiniScreen (CompPlugin *p,
 		 CompScreen *s)
 {
-    int	i;
-
     DECOR_SCREEN (s);
 
-    for (i = 0; i < DECOR_NUM; i++)
-	if (ds->decor[i])
-	    decorReleaseDecoration (s, ds->decor[i]);
-
     if (ds->decoratorStartHandle)
 	compRemoveTimeout (ds->decoratorStartHandle);
 
@@ -1591,6 +1678,7 @@ decorInitWindow (CompPlugin *p,
 		 CompWindow *w)
 {
     DecorWindow *dw;
+    int         i;
 
     DECOR_SCREEN (w->screen);
 
@@ -1598,18 +1686,46 @@ decorInitWindow (CompPlugin *p,
     if (!dw)
 	return FALSE;
 
-    dw->wd    = NULL;
-    dw->decor = NULL;
+    dw->wmWin = None;
+    dw->dmWin = None;
+    
+    dw->wd = NULL;
+
+    for (i = 0; i < DECOR_NUM; i++)
+	dw->decor[i] = 0;
 
     dw->resizeUpdateHandle = 0;
 
     w->base.privates[ds->windowPrivateIndex].ptr = dw;
 
-    if (!w->attrib.override_redirect)
-	decorWindowUpdateDecoration (w);
+    decorCheckForDm (w, FALSE);
+
+    if (w->parent)
+    {
+	if (!w->attrib.override_redirect)
+	{
+	    DECOR_DISPLAY (w->screen->display);
+
+	    decorWindowUpdateDecoration (w,
+					 dd->winDecorAtom,
+					 DECOR_NORMAL);
+	    decorWindowUpdateDecoration (w,
+					 dd->decorAtom[DECOR_ACTIVE],
+					 DECOR_ACTIVE);
+	}
+    }
+    else
+    {
+	DECOR_SCREEN (w->screen);
+
+	if (!dw->dmWin && !ds->decoratorStartHandle)
+	    ds->decoratorStartHandle = compAddTimeout (0, -1,
+						       decorStartDecorator,
+						       w->screen);
+    }
 
     if (w->base.parent)
-	decorWindowAdd (w->screen, w);
+	decorWindowAdd (w->base.parent, w);
 
     return TRUE;
 }
@@ -1618,19 +1734,22 @@ static void
 decorFiniWindow (CompPlugin *p,
 		 CompWindow *w)
 {
+    int i;
+
     DECOR_WINDOW (w);
 
     if (dw->resizeUpdateHandle)
 	compRemoveTimeout (dw->resizeUpdateHandle);
 
     if (w->base.parent)
-	decorWindowRemove (w->screen, w);
+	decorWindowRemove (w->base.parent, w);
 
     if (dw->wd)
 	destroyWindowDecoration (w->screen, dw->wd);
 
-    if (dw->decor)
-	decorReleaseDecoration (w->screen, dw->decor);
+    for (i = 0; i < DECOR_NUM; i++)
+	if (dw->decor[i])
+	    decorReleaseDecoration (w->screen, dw->decor[i]);
 
     free (dw);
 }
diff --git a/plugins/fade.c b/plugins/fade.c
index a30deef..7526750 100644
--- a/plugins/fade.c
+++ b/plugins/fade.c
@@ -196,16 +196,16 @@ fadePreparePaintScreen (CompScreen *s,
 	if (steps < 12)
 	    steps = 12;
 
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = walkDepthFirst (w))
 	{
 	    FadeWindow *fw = GET_FADE_WINDOW (w, fs);
+
 	    fw->steps    = steps;
 	    fw->fadeTime = 0;
-	}
-
+	}	
 	break;
     case FADE_MODE_CONSTANTTIME:
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = walkDepthFirst (w))
 	{
 	    FadeWindow *fw = GET_FADE_WINDOW (w, fs);
 
@@ -221,7 +221,6 @@ fadePreparePaintScreen (CompScreen *s,
 		fw->steps = 0;
 	    }
 	}
-	
 	break;
     }
 
@@ -569,7 +568,7 @@ fadeHandleEvent (CompDisplay *d,
 			option = FADE_SCREEN_OPTION_FULLSCREEN_VISUAL_BELL;
 			if (fs->opt[option].value.b)
 			{
-			    for (w = s->windows; w; w = w->next)
+			    for (w = s->root.windows; w; w = w->next)
 			    {
 				if (w->destroyed)
 				    continue;
@@ -731,7 +730,8 @@ fadeInitDisplay (CompPlugin  *p,
 {
     FadeDisplay *fd;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     fd = malloc (sizeof (FadeDisplay));
diff --git a/plugins/gconf.c b/plugins/gconf.c
index 8d365e0..98094d8 100644
--- a/plugins/gconf.c
+++ b/plugins/gconf.c
@@ -691,22 +691,23 @@ gconfKeyChanged (GConfClient *client,
 }
 
 static void
-gconfSendGLibNotify (CompDisplay *d)
+gconfSendGLibNotify (CompScreen *s)
 {
-    Display *dpy = d->display;
-    XEvent  xev;
+    CompDisplay *d = s->display;
+    Display     *dpy = d->display;
+    XEvent      xev;
 
     xev.xclient.type    = ClientMessage;
     xev.xclient.display = dpy;
     xev.xclient.format  = 32;
 
     xev.xclient.message_type = XInternAtom (dpy, "_COMPIZ_GLIB_NOTIFY", 0);
-    xev.xclient.window	     = d->screens->root;
+    xev.xclient.window	     = s->root.id;
 
     memset (xev.xclient.data.l, 0, sizeof (xev.xclient.data.l));
 
     XSendEvent (dpy,
-		d->screens->root,
+		s->root.id,
 		FALSE,
 		SubstructureRedirectMask | SubstructureNotifyMask,
 		&xev);
@@ -767,10 +768,10 @@ gconfFiniCore (CompPlugin *p,
 }
 
 static Bool
-gconfInitDisplay (CompPlugin  *p,
-		  CompDisplay *d)
+gconfInitScreen (CompPlugin *p,
+		 CompScreen *s)
 {
-    gconfSendGLibNotify (d);
+    gconfSendGLibNotify (s);
 
     return TRUE;
 }
@@ -781,7 +782,8 @@ gconfInitObject (CompPlugin *p,
 {
     static InitPluginObjectProc dispTab[] = {
 	(InitPluginObjectProc) gconfInitCore,
-	(InitPluginObjectProc) gconfInitDisplay
+	(InitPluginObjectProc) NULL,
+	(InitPluginObjectProc) gconfInitScreen
     };
 
     RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
diff --git a/plugins/glx.c b/plugins/glx.c
new file mode 100644
index 0000000..5bf6274
--- /dev/null
+++ b/plugins/glx.c
@@ -0,0 +1,136 @@
+/*
+ * Copyright © 2008 Novell, Inc.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Novell, Inc. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Novell, Inc. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Author: David Reveman <davidr@novell.com>
+ */
+
+#include <compiz-core.h>
+
+static CompMetadata glxMetadata;
+
+static CompOption *
+glxGetDisplayOptions (CompPlugin  *plugin,
+		      CompDisplay *display,
+		      int	  *count)
+{
+    *count = 1;
+    return &display->opt[COMP_DISPLAY_OPTION_ABI];
+}
+
+static Bool
+glxInitDisplay (CompPlugin  *p,
+		CompDisplay *d)
+{
+    int error, event;
+
+    if (!checkPluginABI ("core", CORE_ABIVERSION))
+	return FALSE;
+
+    if (!glXQueryExtension (d->display, &error, &event))
+    {
+	compLogMessage (p->vTable->name, CompLogLevelError,
+			"GLX extension is not available");
+	return FALSE;
+    }
+
+    if (manualCompositeManagement)
+	return TRUE;
+
+    if (d->screens)
+    {
+	compLogMessage (p->vTable->name, CompLogLevelError,
+			"%s plugin must be loaded before screens are "
+			"initialize", p->vTable->name);
+	return FALSE;
+    }
+
+    manualCompositeManagement = TRUE;
+
+    return TRUE;
+}
+
+static CompBool
+glxInitObject (CompPlugin *p,
+	       CompObject *o)
+{
+    static InitPluginObjectProc dispTab[] = {
+	(InitPluginObjectProc) 0, /* InitCore */
+	(InitPluginObjectProc) glxInitDisplay
+    };
+
+    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
+}
+
+static CompOption *
+glxGetObjectOptions (CompPlugin *plugin,
+		    CompObject *object,
+		    int	       *count)
+{
+    static GetPluginObjectOptionsProc dispTab[] = {
+	(GetPluginObjectOptionsProc) 0, /* GetCoreOptions */
+	(GetPluginObjectOptionsProc) glxGetDisplayOptions
+    };
+
+    RETURN_DISPATCH (object, dispTab, ARRAY_SIZE (dispTab),
+		     (void *) (*count = 0), (plugin, object, count));
+}
+
+static Bool
+glxInit (CompPlugin *p)
+{
+    if (!compInitPluginMetadataFromInfo (&glxMetadata, p->vTable->name,
+					 0, 0, 0, 0))
+	return FALSE;
+
+    compAddMetadataFromFile (&glxMetadata, p->vTable->name);
+
+    return TRUE;
+}
+
+static void
+glxFini (CompPlugin *p)
+{
+    compFiniMetadata (&glxMetadata);
+}
+
+static CompMetadata *
+glxGetMetadata (CompPlugin *plugin)
+{
+    return &glxMetadata;
+}
+
+CompPluginVTable glxVTable = {
+    "glx",
+    glxGetMetadata,
+    glxInit,
+    glxFini,
+    glxInitObject,
+    0, /* FiniObject */
+    glxGetObjectOptions,
+    0  /* SetObjectOption */
+};
+
+CompPluginVTable *
+getCompPluginInfo20070830 (void)
+{
+    return &glxVTable;
+}
diff --git a/plugins/minimize.c b/plugins/minimize.c
index eb82370..901c29c 100644
--- a/plugins/minimize.c
+++ b/plugins/minimize.c
@@ -312,7 +312,7 @@ minPreparePaintScreen (CompScreen *s,
 	{
 	    ms->moreAdjust = 0;
 
-	    for (w = s->windows; w; w = w->next)
+	    for (w = s->root.windows; w; w = w->next)
 	    {
 		MIN_WINDOW (w);
 
@@ -395,7 +395,7 @@ minPreparePaintScreen (CompScreen *s,
 
 	if (ms->moreAdjust)
 	{
-	    for (w = s->windows; w; w = w->next)
+	    for (w = s->root.windows; w; w = w->next)
 	    {
 		MIN_WINDOW (w);
 
@@ -431,7 +431,7 @@ minDonePaintScreen (CompScreen *s)
 	CompWindow *w;
 	int	   h;
 
-	for (w = s->windows; w; w = w->next)
+	for (w = s->root.windows; w; w = w->next)
 	{
 	    MIN_WINDOW (w);
 
@@ -762,7 +762,9 @@ minInitDisplay (CompPlugin  *p,
 {
     MinDisplay *md;
 
-    if (!checkPluginABI ("core", CORE_ABIVERSION))
+    if (!checkPluginABI ("core", CORE_ABIVERSION) ||
+	!checkPluginABI ("wm",   CORE_ABIVERSION) ||
+	!checkPluginABI ("glx",  CORE_ABIVERSION))
 	return FALSE;
 
     md = malloc (sizeof (MinDisplay));
